/*
 * Ascii File Capture / Dump Module
 * 
 *	ST users @ Case Western Reserve University
 * Dump is not implemented.
 */

#include <osbind.h>
#include "xmdm.h"

#define sendchar(X)	Cauxout(X) /* Send a character to serial port */

 	/* extern variables */
extern char bufr[];		/* file buffer */
extern unsigned int buf_index;  /* index to file buffer */
extern char capture;		/* Capture flag */

 	/* Global Variables */
static int fd;

/*
 * s_capture() - Start Ascii File Capture
 *
 */
void s_capture()
{
	register char *f;
	char *r_filename();
	
	sendchar(CTRL('S'));

	/* Get filename */
	if((f = r_filename()) == (char *)NULL)
	{
		/* User Cancelled */
		Cconws("Capture is Off\r\n");
		capture = 0;
		sendchar(CTRL('Q'));
		return;
	}
	
	/* create/open the file */
	if((fd = Fcreate(f,0)) < 0)
	{
		if((fd = Fopen(f,1)) < 0)
		{
			/* Did'nt make it */
			Cconws("Could not open ");
			Cconws(f);
			Cconws("\r\nCapture is off\r\n");
			capture = 0;
			hit_key();
			sendchar(CTRL('Q'));
			return;
		}
	}
	
	
	/* All set to capture */
	capture = 1;
	Cconws("Capture is ON\r\n");
	buf_index = 0;
	sendchar(CTRL('Q'));
}

/*
 * c_capture() -  close capture
 *
 */
void c_capture()
{
	sendchar(CTRL('S'));
	if(buf_index > 0)
	{
		/* Flush stuff in file buffer */
		if(Fwrite(fd,(long)buf_index,bufr) != buf_index)
		{
			Cconws("\r\nWarning - error writing capture file\r\n");
			hit_key();
		}
	}

	/* All done */
	buf_index = 0;
	capture = 0;
	Cconws("\r\nCapture is OFF\r\n");
	Fclose(fd);
	sendchar(CTRL('Q'));
}


/*
 * a_capture - Add a char to capture buffer
 *
 */
void a_capture(c)
register int c;
{
	bufr[buf_index++] = c;
	
	if(buf_index == BUFSIZ)
	{
		/* Buffer full dump it to file */
		sendchar(CTRL('S'));
		if(Fwrite(fd,(long)buf_index,bufr) != buf_index)
		{
			/* Problem Writing file */
			EscSeq(j);	/* save cursor position */
			my_screen();	/* switch to my screen memory */
			Cconws("\r\nWarning - error writing capture file\r\n");
			Cconws("Capture Forced OFF\r\n");
			Fclose(fd);
			hit_key();
			his_screen(); /* Back to his screen memory */
			capture = 0;
		}
		buf_index = 0;
		sendchar(CTRL('Q'));
	}
}
