#include <osbind.h>
#include "xmdm.h"

#define clear_screen()  Cconws("\033H\033J")
#define inv()		EscSeq(p)
#define normal()	EscSeq(q)
#define goto(r,c)	EscSeq(Y);Cconout(r+040);Cconout(c+040)
#define ceol()		EscSeq(K)
#define show_cursor()	EscSeq(e)
#define hide_cursor()	EscSeq(f)
 
 	/* Static Globals */
static long nxt_k;	/*  Kilobytes counter */


/*
 * Set up display for file transfers 
 *
 */
void s_display(r_s_g, x_k,filename)
int r_s_g;			/* receive/send/get  */
int x_k;			/* Xmodem/kermit */
char *filename;			/* File name     */
{
	extern long filesize();
	
	clear_screen();
	hide_cursor();
	
	inv();
	goto(2,30);
	Cconws((x_k? "Kermit ":"Xmodem "));
	switch(r_s_g)
	{
	    case RECV:
		Cconws("Receive ");
		break;
		
	    case SEND:
		Cconws("Send ");
		break;
		
	    case GET:
		Cconws("Get  ");
		break;

	    default:
		break;
	}
	Cconws("File");
	normal();
	goto(3,28);
	Cconws("Hit CTRL-C to Abort.");

	goto(5,9);
	Cconws("Filename: ");
	Cconws(filename);

	goto(6,11);
	if(r_s_g == SEND)
	{
		register long fs;
		
		Cconws(" Bytes: ");
		prinl((fs = filesize(filename)));
		if(x_k == XMODEM)
		{
			register long packs;
			
			packs = fs / 128;
			if((packs * 128) != fs)
			    packs++;
			Cconws("  [");
			prinl(packs);
			Cconws(" Packets]");
		}
	}
	else
		Cconws("Kbytes: 0");
	nxt_k = 1024;
	
	goto(8,10);
	Cconws("Packets: 0");
	
	goto(9,9);
	Cconws("Timeouts: 0");

	goto(10,7);
	Cconws("Duplicates: 0");

	goto(11,11);
	Cconws("Errors: 0");
	
	goto(13,9);
	Cconws("Messages: ");
}

/*
 * Update the file name on the display
 */
void u_filename(r_s, name)
register int r_s;
register char *name;
{
	goto(5,19);
	ceol();
	Cconws(name);

	goto(6,11);
	ceol();
	if(r_s == SEND)
	{
		Cconws(" Bytes: ");
		prinl((long)filesize(name));
	}
	else
		Cconws("Kbytes: 0");
	nxt_k = 1024;

}

/*
 * Updates the Kbytes display
 *
 */
void u_bytes(count)
register long count;
{
	/* Only update at the next Kilo Bytes count */
	if (count < nxt_k)
	    return;
	
	goto(6,19);
	printi((int)(nxt_k/1024L));
	nxt_k += 1024L;
	
}

/*
 * Update # of packets on display
 *
 */
void u_packets(count)
register int count;
{
	goto(8,19);
	printi(count);
}

/*
 * Update # of timeouts on display
 *
 */
void u_timeouts(n)
register int n;
{
	goto(9,19);
	printi(n);
}

/*
 * Update # of Duplicates on display
 *
 */
void u_dup(n)
register int n;
{
	goto(10,19);
	printi(n);
}


/*
 * Update # of Errors on display
 *
 */
void u_errors(n)
register int n;
{
	goto(11,19);
	printi(n);
}

/*
 * Put a message on display
 *
 */
void u_message(mesg)
register char *mesg;
{
	ceol();		/* Clear to EOL */
	goto(13,19);
	Cconws(mesg);
}

/*
 * Put a long and message on display
 *
 */
void ui_message(l, mesg)
register long l;
register char *mesg;
{
	ceol();		/* Clear to EOL */
	goto(13,19);
	prinl(l);
	Cconws(mesg);
}

/*
 * Reset the display
 *
 */
void r_display()
{
	goto(5,19);
	ceol();

	goto(6,19);
	ceol();
	nxt_k = 1024;
	
	goto(8,19);
	ceol();
	
	goto(9,19);
	ceol();
	
	goto(10,19);
	ceol();

	goto(11,19);
	ceol();
	
	goto(13,19);
	ceol();
}


/*
 * End display
 *
 */
void e_display()
{
	goto(15,1);
	show_cursor();
}
